#!/usr/bin/perl

use strict;
 
use CGI qw/:all *table/;
use DBI;

my (%conf, $dbh, $sth, $alert_col, $message,
$new_group_bg, $group_list_bg, $member_list_bg, $nonmember_list_bg,
@db_group_list, @db_member_list, @db_nonmember_list, $rfc931, @rfc931,
$db_group_selected);

&setup;

if ($Q::submit eq 'Create') {
	$message = &check_valid_grp_name;
	unless ($message) {
		&create_new_group;
		$message = qq|Group <font color="red">$Q::new_group</font>:
			New group created.|;
		$db_group_selected = $Q::new_group;
		$rfc931 = &get_user_names;
		@db_nonmember_list = &get_nongroup_members;
	}
} elsif ($Q::submit eq 'Edit') {
	$message = &check_select_group;
	unless ($message) {
		$message = qq|Group <font color="red">$Q::group_list</font>: 
			Editing group.|;
		$db_group_selected = $Q::group_list;
		&make_group_lists;
	}
} elsif ($Q::submit eq 'Delete') {
	$message = &check_select_group;
	unless ($message) {
		&del_group($Q::group_list);
		&make_group_lists;
		$message = qq|No group selected.
			Deleted group: <font color="red">$Q::group_list</font>.|;
		undef $db_group_selected;
	}
} elsif ($Q::submit eq 'Add') {
	$message = &check_select_names('add');
	unless ($message) {
		&add_names_to_group;
		$message = qq|Group <font color="red">$Q::selected_group</font>:
			Members added to group.|;
	}
	&make_group_lists;
} elsif ($Q::submit eq 'Add All') {
	&make_group_lists;
	$message = &check_add_all;
	unless ($message) {
		&add_names_to_group('all');
		$message = qq|Group <font color="red">$Q::selected_group</font>:
			Members added to group.|;
		&make_group_lists;
	}
} elsif ($Q::submit eq 'Remove') {
	$message = &check_select_names('remove');
	unless ($message) {
		&remove_names_from_group;
		$message = qq|Group <font color="red">$Q::selected_group</font>:
			Members removed from group.|;
	}
	&make_group_lists;
} elsif ($Q::submit eq 'Remove All') {
	&make_group_lists;
	$message = &check_remove_all;
	unless ($message) {
		&remove_names_from_group('all');
		$message = qq|Group <font color="red">$Q::selected_group</font>:
			Members removed from group.|;
		&make_group_lists;
	}
} else {
	$message = "Squidalyser group manager: no group selected.";
}

@db_group_list = &get_group_list;
my $content = &make_input_page;
print header, $content;
&dbdisconnect;

exit;

sub setup {
	import_names('Q');
	$alert_col = '#98cbcb';
	open (CONF, "< /usr/local/squidparse/squidalyser.conf") or die $!;
	while (my $line = <CONF>) {
		chomp($line);
		$line =~ /^\#/ and next;
		$line =~ /^$/ and next;
		my ($varname, $varvalue) = split(/\s+/, $line);
		$conf{$varname} = $varvalue;
	}
	close CONF;
	dbconnect(
		$conf{dbhost},
		$conf{dbname},
		$conf{dbuser},
		$conf{dbpass}
	);
	$db_group_selected = $Q::selected_group;
}

sub make_group_lists {
	$rfc931 = &get_user_names;
	@db_member_list = &get_group_members;
	@db_nonmember_list = &get_nongroup_members;
}

sub check_remove_all {
	my $message;
	unless ($Q::selected_group) {
		$message = 'No group selected. Select and edit, or create a group first.';
		return $message;
	}
	if ($#db_member_list == -1) {
		$message = qq|Group has no members. Editing group:
			<font color="red">$Q::group_list</font>|;
	}
	return $message;
}

sub check_add_all {
	my $message;
	unless ($Q::selected_group) {
		$message = 'No group selected. Select and edit, or create a group first.';
		return $message;
	}
	if ($#db_member_list == $#{$rfc931}) {
		$message = qq|No more members to add. Editing group:
			<font color="red">$Q::group_list</font>|;
	}
	return $message;
}

sub create_new_group {
	my $grp_name_q = $dbh->quote($Q::new_group);
	$dbh->do("INSERT INTO groups VALUES (NULL, $grp_name_q, 1)") or die $dbh->errstr;
	return 0;
}

sub del_group {
	my $group = shift;
	my $group_q = $dbh->quote($group);
	my $query = qq|SELECT id FROM groups WHERE group_name=$group_q|;
	my $sth = $dbh->prepare($query);
	$sth->execute;
	my $group_id = $sth->fetchrow;
	$sth->finish;
	$dbh->do("DELETE FROM groups WHERE id=$group_id") or die $dbh->errstr;
	$dbh->do("DELETE FROM members WHERE group_id=$group_id") or die $dbh->errstr;
	return;
}

sub check_select_names {
	my $switch = shift;
	my ($message, @list);
	unless ($Q::selected_group) {
		$message = 'No group selected. Select and edit, or create a group first.';
	}
	if ($switch eq 'add') {
		@list = param('nonmember_list');
	} else {
		@list = param('member_list');
	}
	if ($#list == -1) {
		$message = qq|Please select the name(s) to
			$switch (group $Q::group_list).|;
	}
	if ($message) {
		if ($switch eq 'add') {
			$nonmember_list_bg = $alert_col;
		} else {
			$member_list_bg = $alert_col;
		}
	}
	return $message;
}

sub remove_names_from_group {
	my $switch = shift;
	my $message;
	my $group_q = $dbh->quote($Q::group_list);
	my $sth = $dbh->prepare("SELECT id FROM groups WHERE group_name=$group_q");
	$sth->execute;
	my $group_id = $sth->fetchrow;
	$sth->finish;
	if ($switch eq 'all') {
		$dbh->do("DELETE FROM members WHERE group_id=$group_id") or die $dbh->errstr;
	} else {
		my @list = param('member_list');
		my $sth = $dbh->prepare("DELETE FROM members WHERE rfc931=? AND group_id=$group_id");
		foreach my $name (@list) { $sth->execute($name) or die $dbh->errstr };
		$sth->finish;
	}
	return;
}

sub add_names_to_group {
	my $switch = shift;
	my @list;
	if ($switch eq 'all') {
		@list = @db_nonmember_list;
	} else {
		@list = param('nonmember_list');
	}
	#my $group_q = $dbh->quote($Q::group_list);
	my $group_q = $dbh->quote($db_group_selected);
	my $sth = $dbh->prepare("SELECT id FROM groups WHERE group_name=$group_q");
	$sth->execute;
	my $group_id = $sth->fetchrow;
	$sth->finish;
	$sth = $dbh->prepare("INSERT INTO members VALUES (NULL, $group_id, ?)");
	foreach my $name (@list) { $sth->execute($name) or die $dbh->errstr };
	$sth->finish;
	return;
}

sub get_group_list {
	my @list;
	my $query = 'SELECT group_name FROM groups ORDER BY group_name';
	my $sth = $dbh->prepare($query);
	$sth->execute or do {
		print $query;
		die $dbh->errstr;
	};
	while (my $group_name = $sth->fetchrow) { push @list, $group_name };
	if ($#list == -1) { push @list, 'None found' };
	return @list;
}

sub get_group_members {
	my @members;
	my $group_q = $dbh->quote($db_group_selected);
	my $query = qq|
		SELECT DISTINCT(rfc931) FROM members, groups
		WHERE group_id=groups.id
		AND group_name=$group_q
		ORDER BY rfc931
	|;
	my $sth = $dbh->prepare($query);
	$sth->execute;
	while (my $rfc931 = $sth->fetchrow) { push @members, $rfc931 };
	return @members;
}

sub get_nongroup_members {
	my @non_members;
	my @all_users = @{$rfc931};
	my %exists;
	foreach (@db_member_list) { $exists{$_} = 1 };
	foreach (@all_users) { push @non_members, $_ unless ($exists{$_}) };
	return @non_members;
}

sub get_user_names {
	my $query = qq|
		SELECT DISTINCT(rfc931)
		FROM logfile
		WHERE rfc931 != '-'
		ORDER BY rfc931
	|;
	my $rfc931 = $dbh->selectcol_arrayref($query);
	return $rfc931;
}

sub check_select_group {
	my $message;
	if (param('group_list') eq 'None found') {
		$message = 'You need to create a group first.';
		undef $Q::group_list;
	}
	return $message;
}

sub check_valid_grp_name {
	my $grp_name = $Q::new_group;
	my $message;
	if ($grp_name !~ /^\w+$/) {
		$message = qq|"$grp_name" is not a valid group name.
			Please use A-Z, a-z, 0-9 and _ only.|;
	}
	if (length($grp_name) < 1) {
		$message = 'Please enter a name for the group.';
	} elsif (length($grp_name > 32)) {
		$message = qq|The name "$grp_name" is too long.
		Please use another name.|;
	}
	unless ($message) {
		my $grp_name_q = $dbh->quote($grp_name);
		my $sth = $dbh->prepare("SELECT id FROM groups
			WHERE group_name=$grp_name_q");
		$sth->execute;
		my $group_id = $sth->fetchrow;
		$sth->finish;
		if ($group_id) {
			$message = qq|The group "$grp_name" already exists.
				Please use another name.|;
		}
	}
	if ($message) {
		$new_group_bg = $alert_col;
		undef $Q::new_group;
		undef $Q::group_list;
	}
	return $message;
}

sub make_input_page {
	my $form =
	start_html({-bgcolor=>'linen', -title=>'Squidalyser v0.2: Group Manager'}).
	start_form.
	start_table(
		{-bgcolor=>'linen',
		-border=>0,
		-cellspacing=>0,
		-cellpadding=>10,
		-width=>'100%'}
	) .
	Tr({-valign=>'top'},
		td({-colspan=>3},
			a({-href=>'./squidalyser.pl'}, 
				img(
					{-src=>'/icons/sq-squid0.gif',
					-alt=>'squidalyser',
					-border=>0}
				)
			),
			a({-href=>'./wordlist.pl'},
				img(
					{-src=>'/icons/sq-wordl0.gif',
					-alt=>'word list',
					-border=>0}
				)
			),
			a({-href=>'./groupmanage.pl'},
				img(
					{-src=>'/icons/sq-group1.gif',
					-alt=>'group manager',
					-border=>0}
				)
			),
		)
	) .
	Tr({-valign=>'top'},
		td({-colspan=>3, -height=>2},
			img(
				{-src=>'/icons/blue-square.gif',
				-width=>'100%',
				-height=>4}
			)
		),
	) .
	Tr({-valign=>'top'},
		td({-colspan=>3},
			b($message)
		),
	) .
	Tr({-valign=>'top'},
		td({-colspan=>3, -height=>2},
			img(
				{-src=>'/icons/blue-square.gif',
				-width=>'100%',
				-height=>4}
			)
		),
	) .
	Tr({-valign=>'top', -bgcolor=>"$new_group_bg"},
		td({-width=>'30%'},
			textfield(
				-name=>'new_group',
				-size=>32,
				-maxlength=>64,
				-value=>$Q::new_group
			)
		),
		td({-width=>'20%'},
			submit(
				-name=>'submit',
				-value=>'Create'
			)
		),
		td(
			b('Create new group'),
			p,
			small(
				'Alphanumeric characters (A-Z, a-z,
				0-9 and underscore) only.'
			)
		),
	) .
	Tr({-valign=>'top'},
		td({-colspan=>3, -height=>2},
			img(
				{-src=>'/icons/blue-square.gif',
				-width=>'100%',
				-height=>4}
			)
		),
	);
	unless ($db_group_list[0] eq 'None found') {
		$form .=
		Tr({-valign=>'top', -bgcolor=>"$group_list_bg"},
			td(
				popup_menu(
					-name=>'group_list',
					-values=>\@db_group_list,
					-default=>$db_group_selected
				)
			),
			td(
				submit(
					-name=>'submit',
					-value=>'Edit'
				),
				'&nbsp;',
				submit(
					-name=>'submit',
					-value=>'Delete'
				),
			),
			td(
				b('Edit or delete group'),
				p,
				small('Select a group to edit or delete.')
			),
		) .
		Tr({-valign=>'top'},
			td({-colspan=>3, -height=>2},
				img(
					{-src=>'/icons/blue-square.gif',
					-width=>'100%',
					-height=>4}
				)
			),
		);
	}
	if (($Q::new_group or $Q::group_list) and $db_group_list[0] ne 'None found') {
		$form .=
		Tr({-valign=>'top', -bgcolor=>"$member_list_bg"},
			td(
				scrolling_list(
					-name=>'member_list',
					-values=>\@db_member_list,
					-multiple=>'true',
					-size=>10
				)
			),
			td(
				submit(-name=>'submit', -value=>'Remove'),
				'&nbsp;',
				submit(-name=>'submit', -value=>'Remove All'),
			),
			td(
				b('Members of group'),
				p,
				small('Select member(s) to remove from the current group.')
			),
		) .
		Tr({-valign=>'top'},
			td({-colspan=>3, -height=>2},
				img(
					{-src=>'/icons/blue-square.gif',
					-width=>'100%',
					-height=>4}
				)
			),
		) .
		Tr({-valign=>'top', -bgcolor=>"$nonmember_list_bg"},
			td(
				scrolling_list(
					-name=>'nonmember_list',
					-values=>\@db_nonmember_list,
					-multiple=>'true',
					-size=>10
				)
			),
			td(
				submit(-name=>'submit', -value=>'Add'),
				'&nbsp;',
				submit(-name=>'submit', -value=>'Add All'),
			),
			td(
				b('Non-members of group'),
				p,
				small('Select user(s) to add to the current group.')
			),
		) .
		Tr({-valign=>'top'},
			td({-colspan=>3, -height=>2},
				img(
					{-src=>'/icons/blue-square.gif',
					-width=>'100%',
					-height=>4}
				)
			),
		) .
		Tr({-valign=>'top'},
			td({-colspan=>3, -height=>2},
				p({-align=>'center'},
					small(
						a({-href=>'http://ababa.org/'},
						'Squidalyser Homepage')
					)
				)
			),
		);
	}
	$form .= qq|<input type=hidden name='selected_group' value="$db_group_selected">|;
	$form .= end_table . end_form . end_html;
	return $form;
}

sub dbconnect {
	my ($dbhost, $dbname, $dbuser, $dbpass) = @_;
	$dbh = DBI->connect("DBI:mysql:$dbname:$dbhost",$dbuser,$dbpass)
		or die (DBI::errstr);
}

sub dbdisconnect {
	$sth and $sth->finish;
	($dbh and $dbh->disconnect) or die (DBI::errstr);
}
