#!/usr/bin/perl

use strict;
use CGI qw/:standard/;
use GD::Graph::bars;
use GD::Graph::colour;
use GD::Graph::Data;
use URI::Escape;

my (@labels, @values, $title, $ylabel);

my @data_string = split(/\&/, $ENV{QUERY_STRING});
foreach my $pair (@data_string) {
	my ($label, $value) = split(/=/, $pair);
	$label = uri_unescape($label);
	if ($label eq 'title') {
		$value = uri_unescape($value);
		$title = $value;
	} elsif ($label eq 'ylabel') {
		$value = uri_unescape($value);
		$ylabel = $value;
	} else {
		push @labels, $label;
		push @values, $value;
	}
}

my $data = [
	[ @labels ],
	[ @values ],
];

my $my_graph = GD::Graph::bars->new();

$my_graph->set(
	title		=> $title,
	x_label         => 'Username',
	y_label         => $ylabel,
	bar_spacing     => 8,
	shadow_depth    => 4,
	shadowclr       => 'dred',
	transparent     => 1,
)
or warn $my_graph->error;

my $format = $my_graph->export_format;
print header("image/$format");
binmode STDOUT;
print $my_graph->plot($data)->$format();

exit;
